{#############################################################################

Test Application for the P5 DataGlove Component

P5 is a registered Trademark of Essential Reality LLC
http://www.essentialreality.com

Author:       Andreas Ralf Schwarz (andreas.schwarz@hamburg.de)
Description:  P5 DataGlove Component for Delphi
Creation:     November 27, 2002
Version:      1.1
EMail:        andreas.schwarz@hamburg.de
Support:      No support currently
Legal issues: Copyright (C) 2002 Andreas Schwarz
              P5: Copyright (c) 2001 Essential Reality LLC

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. You must register this software by sending a email to

                   <andreas.schwarz@hamburg.de>  with your full name and location

History:


#############################################################################}
unit TestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DataGlove, StdCtrls, ExtCtrls, ComCtrls, ShellApi;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    ProgressBar5: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    GroupBox2: TGroupBox;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    GroupBox3: TGroupBox;
    Button1: TButton;
    lbX: TLabel;
    lbY: TLabel;
    lbZ: TLabel;
    Button2: TButton;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    Label17: TLabel;
    TrackBar5: TTrackBar;
    Label18: TLabel;
    TrackBar6: TTrackBar;
    Label19: TLabel;
    Image1: TImage;
    P5DataGlove1: TP5DataGlove;
    GroupBox4: TGroupBox;
    ListView1: TListView;
    Label14: TLabel;
    Edit1: TEdit;
    Label15: TLabel;
    Edit2: TEdit;
    Label16: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label20: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Button3: TButton;
    procedure P5DataGlove1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Label9Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure SetButtonDisplay(Shape : TShape; Value : Boolean);
    procedure SetFingerState(Finger : TProgressBar; FingerLabel : TLabel;  Value : Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SetButtonDisplay(Shape : TShape; Value : Boolean);
begin
        if Value then
         Shape.Brush.Color := clRed else Shape.Brush.Color := clWhite;
end;

procedure TForm1.SetFingerState(Finger : TProgressBar; FingerLabel : TLabel; Value : Integer);
begin
        Finger.Max := P5BEND_MAX;
        Finger.Position := Value;
        FingerLabel.Caption := IntToStr(Value);
end;

procedure TForm1.P5DataGlove1Timer(Sender: TObject);
var X, Y, Z, R, W, P : Integer;

        procedure SetAxes(TrackBar : TTrackBar; Value : Integer);
         begin
          if Value > 15 then
           TrackBar.Position := 15
          else if Value < -15 then
           TrackBar.Position := 0
          else if Value > 0 then
           TrackBar.Position := 15 + (15 - Value)
          else if Value < 0 then
           TrackBar.Position := 15 - (Value * -1)
          else
           TrackBar.Position := 15;
         end;

begin

        SetButtonDisplay(Shape1, P5DataGlove1.ButtonA);
        SetButtonDisplay(Shape2, P5DataGlove1.ButtonB);
        SetButtonDisplay(Shape3, P5DataGlove1.ButtonC);
        SetButtonDisplay(Shape4, P5DataGlove1.ButtonD);

        SetFingerState(ProgressBar1, Label1, P5DataGlove1.FingerThumb);
        SetFingerState(ProgressBar2, Label2, P5DataGlove1.FingerIndex);
        SetFingerState(ProgressBar3, Label3, P5DataGlove1.FingerMiddle);
        SetFingerState(ProgressBar4, Label4, P5DataGlove1.FingerRing);
        SetFingerState(ProgressBar5, Label5, P5DataGlove1.FingerPinky);

        with ListView1 do
         begin

          Items[0].SubItems[0] := FloatToStr(P5DataGlove1.Position.PosX);
          Items[0].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.PosX);
          Items[0].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.PosX);

          Items[1].SubItems[0] := FloatToStr(P5DataGlove1.Position.PosY);
          Items[1].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.PosY);
          Items[1].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.PosY);

          Items[2].SubItems[0] := FloatToStr(P5DataGlove1.Position.PosZ);
          Items[2].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.PosZ);
          Items[2].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.PosZ);

          Items[3].SubItems[0] := FloatToStr(P5DataGlove1.Position.Roll);
          Items[3].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.Roll);
          Items[3].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.Roll);

          Items[4].SubItems[0] := FloatToStr(P5DataGlove1.Position.Pitch);
          Items[4].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.Pitch);
          Items[4].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.Pitch);

          Items[5].SubItems[0] := FloatToStr(P5DataGlove1.Position.Yaw);
          Items[5].SubItems[1] := FloatToStr(P5DataGlove1.PositionOptimizedRelative.Yaw);
          Items[5].SubItems[2] := FloatToStr(P5DataGlove1.PositionOptimizedAbsolute.Yaw);
         end;

        X := Trunc(P5DataGlove1.Position.PosX) div 10;
        Y := Trunc(P5DataGlove1.Position.PosY) div 10;
        Z := Trunc(P5DataGlove1.Position.PosZ) div 10;

        R := Trunc(P5DataGlove1.Position.Roll) div 10;
        W := Trunc(P5DataGlove1.Position.YAW) div 10;
        P := Trunc(P5DataGlove1.Position.Pitch) div 10;

        lbZ.Caption := 'Z = ' + IntToStr(Z);
        lbX.Caption := 'X = ' + IntToStr(X);
        lbY.Caption := 'Y = ' + IntToStr(Y);

        SetAxes(TrackBar1, X);
        SetAxes(TrackBar2, Y);
        SetAxes(TrackBar3, Z);

        SetAxes(TrackBar4, R);
        SetAxes(TrackBar5, W);
        SetAxes(TrackBar6, P);


end;

procedure TForm1.Button1Click(Sender: TObject);
begin
        Close;
end;

procedure TForm1.Label9Click(Sender: TObject);
begin
        ShellExecute(0, 'open', 'mailto:andreas.schwarz@hamburg.de', '', '', 1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        P5DataGlove1.ResetPosition;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        Edit2.Text := IntToStr(Screen.Width);
        Edit4.Text := IntToStr(Screen.Height);
        Button3Click(Self);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin

        P5DataGlove1.UpdateInvertAxes(True, False, False);


        P5DataGlove1.UpdateRegion (
          StrToInt(Edit1.Text),  StrToInt(Edit2.Text),
          StrToInt(Edit3.Text),  StrToInt(Edit4.Text),
          StrToInt(Edit5.Text),  StrToInt(Edit6.Text)
        );

end;

end.
