Attribute VB_Name = "DataGlove"

'#############################################################################
'
'Test Application for the P5 DataGlove Component
'
'P5 is a registered Trademark of Essential Reality LLC
'http://www.essentialreality.com
'
'Author:       Andreas Ralf Schwarz (andreas.schwarz@hamburg.de)
'Description:  P5 DataGlove Component for Delphi - VB Example
'Creation:     November 27, 2002
'Version:      1.1
'EMail:        andreas.schwarz@ hamburg.de
'Support:      No support currently
'Legal issues: Copyright (C) 2002 Andreas Schwarz
'              P5: Copyright (c) 2001 Essential Reality LLC
'
'              This software Is provided 'as-is', without any express or
'              implied warranty.  In no event will the author be held liable
'              for any  damages arising from the use of this software.
'
'              Permission is granted to anyone to use this software for any
'              purpose, including commercial applications, and to alter it
'              and redistribute it freely, subject to the following
'
'restrictions:

'              1. The origin of this software must not be misrepresented,
'                 you must not claim that you wrote the original software.
'                 If you use this software in a product, an acknowledgment
'                 in the product documentation would be appreciated but is
'                 not required.
'
'              2. Altered source versions must be plainly marked as such, and
'                 must not be misrepresented as being the original software.
'
'              3. This notice may not be removed or altered from any source
'                 distribution.
'
'              4. You must register this software by sending a email to
'
'                   <andreas.schwarz@hamburg.de>  with your full name and location
'
'#############################################################################}


Const P5BEND_MAX = 63
Const P5MOTION_NORMALAXIS = 1
Const P5MOTION_INVERTAXIS = -1

Type TP5ButtonData
    ButtonA As Boolean
    ButtonB As Boolean
    ButtonC As Boolean
    ButtonD As Boolean
End Type

Type TP5BendData
    Thumb As Byte
    Index As Byte
    Middle As Byte
    Ring As Byte
    Pinky As Byte
End Type
        
Type TP5PositionData
    PosX As Single
    PosY As Single
    PosZ As Single
    Yaw As Single
    Pitch As Single
    Roll As Single
End Type

Type TP5Region
    StartX As Integer
    EndX As Integer
    StartY As Integer
    EndY As Integer
    StartZ As Integer
    EndZ As Integer
End Type

       
Declare Function P5BendState Lib "p5wrapper.dll" (ByVal BendData As TP5BendData) As Long
Declare Function P5ButtonState Lib "p5wrapper.dll" (ByVal ButtonData As TP5ButtonData) As Long
Declare Function P5FreeDevice Lib "p5wrapper.dll" () As Boolean
Declare Function P5InitializeDevice Lib "p5wrapper.dll" () As Boolean
Declare Function P5InvertMouse Lib "p5wrapper.dll" (ByVal xaxis As Long, ByVal yaxis As Long, ByVal zaxis As Long) As Long
Declare Function P5IsDevicePresent Lib "p5wrapper.dll" () As Boolean
Declare Function P5Position Lib "p5wrapper.dll" (ByVal PosNormal As TP5PositionData, ByVal PosOptAbs As TP5PositionData, ByVal PosOptRel As TP5PositionData) As Long
Declare Function P5SetClipRegion Lib "p5wrapper.dll" (ByVal xstart As Long, ByVal xend As Long, ByVal ystart As Long, ByVal yend As Long, ByVal zstart As Long, ByVal zend As Long) As Long


        


